
/* ********************************************************************************************************************************************
* FileName:        	SPI_MAIN.c
* Dependencies:    Header (.h) files if applicable, see below
* Processor:       	PIC18F
* Compiler:        	MCC18 v3.30 or higher
 REVISION HISTORY:
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Author        	Date      	Comments on this revision
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* JP	   05/08/13         	First release of source file
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*
* ADDITIONAL NOTES:
* Code uses the Peripheral library support available with MCC18 Compiler
* Code Tested on:
* 
* The Processor starts with the External Crystal (8 Mhz).
*
* SDO ,SDI, SCK & SS must be connected to the corresponding in slave
*
******************************************************************************************************************************************* */
#include <p18f46j50.h>
#include <delays.h>

//  #pragma config OSC = INTIO7       //  Internal oscillator block, CLKO function on RA6, port function on RA7 
 //#pragma config OSC = INTOSCPLL      // internal oscillator with PLL  
#pragma config OSC=HS, FCMEN=ON, IESO=ON, XINST=OFF 
typedef int D_n;
typedef unsigned int D_un;
typedef unsigned char D_uc;
typedef unsigned long int D_uln;
typedef void null;

#define __Config_SPI1 SPI_init()
#define __config_RCC Clock_init()
#define __SPI_Cmd PORTAbits.RA5 = 0
#define __SPI_STOP PORTAbits.RA5 = 1
D_uc gdata;
D_uc spi_write(D_uc );
null SPI_init(null)
{
   ODCON3=0x01; 			//Initialize ODCON3 register (optional open-drain output control) for SPI1.

  TRISCbits.TRISC7 = 0; 	// SDO1 pin is ouput type
  TRISBbits.TRISB5 = 1; 	// SDI1 pin is input type
  TRISBbits.TRISB4 = 0; 	// SCK1 pin is ouput type
  TRISAbits.TRISA5 = 0; 	// SS1 pin is ouput type
  SSP1STAT		 =0b00000000;
  SSP1CON1		 =0b00100000;//SPI Clock = FOSC/4
  __SPI_STOP;
}

null Clock_init(null)
{
	//CONFIG1L=
//CONFIG2L=0x03;
//CONFIG2Lbits.FOSC1=1;
//CONFIG2Lbits.FOSC0=1; 		  //INTOSCPLLO, internal oscillator with PLL software controlled, CLKO on RA6, port function on RA7
    OSCTUNEbits.INTSRC = 1;     //31.25 kHz device clock derived from 8 MHz INTOSC source (divide-by-256 enabled 
    OSCCONbits.IRCF0 = 1;          //8 MHz (INTOSC drives clock directly) 
    OSCCONbits.IRCF1 = 1; 
    OSCCONbits.IRCF2 = 1; 
    
    OSCCONbits.IDLEN = 0;        //Device enters Sleep mode when a SLEEP instruction is executed 
    OSCCONbits.SCS1 = 0;        //Internal oscillator block 
    OSCCONbits.SCS0 = 0;        //Internal oscillator block
    while(!OSCCONbits.OSTS );    //Oscillator Start-up Time-out Status bit 
  //  while(OSCCONbits.IOFS == 0);    //INTOSC Frequency Stable bit 
    
    OSCTUNEbits.PLLEN = 1;         //PLL enabled for INTOSC (4 MHz and 8 MHz only) 

//    while(OSCCONbits.IOFS == 0){}    //INTOSC Frequency Stable bit 
}
null main(null)
{
__config_RCC;
__Config_SPI1;

   while(1)
     {
	     __SPI_Cmd ;
	     spi_write(0xAC);
	    while(SSP2STATbits.BF==0); 
	     spi_write(0xFF);
	     while(SSP2STATbits.BF==0); 
	   //  __delay_ms(3);
	     __SPI_STOP;
      }
}

D_uc spi_write(D_uc gdata)
{
SSP1BUF=gdata;
return SSP1BUF; 
}
